<?php
class Comment extends XmlItem {
    var $id;        // int
    var $itemid;    // int
	var $public;    // int
    var $posted;    // date (YYYY-MM-DD)
    var $creator;   // int
	var $ipaddr;    // string
    var $bread;     // text
    
    function Comment() {
    	$this->posted = date("Y-m-d H:i:s", time());
    }

    function parseItem($xmldata) {
        $this->id      = $xmldata["id"];
        $this->itemid  = $xmldata["itemid"];
    	$this->public  = $xmldata["public"];
        $this->posted  = $xmldata["posted"];
        $this->creator = stripslashes($xmldata["creator"]);
        $this->ipaddr  = $xmldata["ipaddr"];
        $this->bread   = stripslashes($xmldata["bread"]);
    }

    function getId() {
        return $this->id;
    }

	function togglePublic() {
    	$this->public = ! $this->public;
    }

    function isPublic() {
        return $this->public;
    }

	function getAnchor() {
		return $this->itemid . "-" . $this->id;
	}

	function contains(&$word) {
		if (! $this->public) {
			return false;
		}
	
		if (stripos($this->bread, $word) !== false) {
			return true;
		} else if (stripos($this->creator, $word) !== false) {
			return true;
		}
		
		return false;
	}

	function touch() {
		$this->modified = date("Y-m-d H:i:s", time());
	}
    
    static function loadItems($itemarr, $maxid, $file) {
        $items = XmlItem::getItemsFromXml($file, "comment");

        if (! is_array($items) || sizeof($items) == 0) {
            return null;
        }

        foreach ($items as $item) {
            $tmp = new Comment();
            $tmp->parseItem($item);
            $itemarr[] = $tmp;

            if ($tmp->id > $maxid) {
                $maxid = $tmp->id;
            }
        }
    }
}
?>
