<?php
class Language {
	var $lang;

	function Language($l = null) {
	    $this->lang = array();
	    
		if ($l != null) {
			$this->lang = Language::load($l);
		}
	}
	
	function getstring($key) {
		if (array_key_exists($key, $this->lang)) {
			return $this->lang[$key];
		}

		return null;
	}
	
	function loadlang($lang) {
		$this->lang = Language::load(&$lang);
	}
	
	private static function load($lang) {
	    $config   = Configuration::getInstance();
		$langfile = $config->basedir() . $config->get('langdir') . "/lang_" . $lang . ".txt";

		if (! @file_exists($langfile)) {
			debugmessage("Requested language (" . $langfile . ") doesn't exist.");
			return array();
		}

		$langdata = file($langfile);
		foreach ($langdata as $row) {
			if (strlen(trim($row)) == 0) {
					continue;
			}

			/* This should work for tabless lang-files as well */
			$splitrow = preg_split("/([\s]+)/", $row, 2);
			$tmp[trim($splitrow[0])] = trim($splitrow[1]);
		}

		return $tmp;
	}
}
?>
