<?php
class Response {
    static $instance = null;
    var    $title;
    var    $body;
    
    var    $alternatingStyles;
    var    $naviBefore;
    var    $naviAfter;
    
    function Response() {
        if (isset(Response::$instance) && Response::$instance != null) {
            die("Response should only be instantiated via the getInstance() method");
        }
    }
    
    /* Response is a singleton class and getInstance should be used to instantiate */
    static function getInstance() {
        if (Response::$instance == null) {
            Response::$instance = new Response();
        }
        
        return Response::$instance;
    }
    
    /* Get meta */
    function getHead() {
        global $themedir;

        $config = Configuration::getInstance();
        $ret    = array(                
                sprintf('<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" %s>', ($config->get("xhtml") ? "/":"")),
                sprintf('<meta http-equiv="content-language" content="%s">', getcurrentlang()),
                sprintf('<meta name="generator" content="ElfBB %s" %s>', $this->getVersion(), ($config->get("xhtml") ? "/":"")), 
                sprintf('<title>%s</title>', $this->getTitle()),
                sprintf('<link rel="stylesheet" type="text/css" href="%s/style.css" %s>', $themedir, ($config->get("xhtml") ? "/":"")),
                '<script src="assets/js/js-admin.js.php" type="text/javascript"></script>'
            );
        
        return implode("\n", $ret);
    }
    
    /* This is provided only as a convenience */
    function theHead() {
        print($this->getHead());
    }
    
    function getRequestTime() {
        global $reqstart;
        
        return microtime(true) - $reqstart;
    }
    
    function setLinkStyle($before = "", $after = "") {
        $this->naviBefore = $before;
        $this->naviAfter  = $after;
    }
    
    function setAlternatingStyles($even = "", $odd = "") {
        $this->alternatingStyles = array($even, $odd);
    }
    
    function getAlternateStyle($n) {
        return $this->alternatingStyles[$n % 2];
    }
    
    function wrapLink($href) {
        return sprintf("%s%s%s", $this->naviBefore, $href, $this->naviAfter);
    }
    
    function setSearchResults($results) {
        $this->searchResults = $results;
    }
    
    /* Get navigation items */
    function getNavi($ident, $href=true, $linkStyleBefore = null, $linkStyleAfter = null) {
        $ident = strtolower($ident);
        
        if ($linkStyleBefore != null) { $this->naviBefore = $linkStyleBefore; }
        if ($linkStyleAfter != null) { $this->naviAfter = $linkStyleAfter; }
        
        $u_home   = new Url(Url::homeurl(), "nofollow");
        $u_logout = new Url(Url::homeurl(), "nofollow"); $u_logout->addparam("logout", "");
        $u_cpanel = new Url(Url::homeurl(), "nofollow"); $u_cpanel->addparam("act", "cpanel");
        $u_post   = new Url(Url::homeurl(), "nofollow"); $u_post->addparam("act", "post");
        $u_search = new Url(Url::homeurl()); $u_search->addparam("act", "search");
        $elfhome  = new Url("http://elfbb.nikc.org/");
        
        // public
        if ($ident == 'home') {
            return $href ? $this->wrapLink($u_home->tohref(getlangstring("PROMPT_HOME"))) : $u_home->getUrl();
        } else if ($ident == 'post') {
            return $href ? $this->wrapLink($u_post->tohref(getlangstring("FUNC_POST"))) : $u_post->getUrl();
        } 
        // admin
        else if ($ident == 'logout') {
            return $href ? $this->wrapLink($u_logout->tohref(getlangstring("ADMIN_LOGOUT"), "admin")) : $u_logout->getUrl();
        } else if ($ident == 'cpanel') {
            return $href ? $this->wrapLink($u_cpanel->tohref(getlangstring("ADMIN_CPANEL"), "admin")) : $u_cpanel->getUrl();
        } 
        // other
        else if  ($ident == 'search') {            
            return $href ? $this->wrapLink($u_search->tohref("Search")) : $u_search->getUrl();
        } else if ($ident == 'elfhome') {
            return $href ? $this->wrapLink($elfhome->tohref("ELF Lightweight Forum")) : $elfhome->getUrl();
        }
    }
    
    /* ELF Version */
    function getVersion() {
        $config = Configuration::getInstance();
        return trim(file_get_contents($config->basedir() . "/VERSION"));
    }
    
    /* Forum title */
    function getTitle() {
        $config = Configuration::getInstance();
        return $config->get('forumname');
    }
    
    /* Get all languages */
    function getLanguages() {
        $langs = getlangmenu();        
        $ret   = "";
        
        foreach ($langs as $lang) {
            $ret .= $this->wrapLink($lang);
        }
        
        return $ret;
    }
    
    /* Returns the pagination links */
    /*
        Disabled for now due to need for redesign
    */
    function getPages() {
        return "";
    }
    
    /* Set, get and print body */
    function setBody($body) {
        $this->body = $body;
    }
    
    function getBody() {
        return $this->body;
    }
    
    /* This is provided only as a convenience */
    function theBody() {
        print($this->getBody());
    }
}
?>