<?php
class Url {
	var $data;
	var $rel;
	var $id;
	var $lang;
    
	function Url($_href, $_rel = null) {
		$this->data = $_href;
        $this->rel  = $_rel;
	}
	
	/* Add a GET parameter to the URL */
	function addparam($name, $value) {
		$this->remparam($name);

		if (strpos($this->data, "?") === false) {
			$this->data .= "?" . $name . "=" . $value;
		} else {
			$this->data .= "&amp;" . $name . "=" . $value;
		}
	}
	
	/* Add lang attribute to link */
	function addlang($lang) {
	    $this->lang = $lang;
	}
	
	/* Removes a GET parameter from the URL */
	function remparam($name) {
		if (strpos($this->data, $name . "=") === false) {
			return;
		}
		
		$start = strpos($this->data, $name."=");
		$end   = strpos($this->data, "&amp;", $start);
		
		if ($end !== false) {
			$this->data = substr($this->data, 0, $start) . substr($this->data, $end + 5);
		} else { // is the last param
		
			if ($start - 5 > 0 && $this->data[$start - 5] == "&") {
				$this->data = substr($this->data, 0, $start - 5);
			} else {
				$this->data = substr($this->data, 0, $start - 1);
			}
		}
	}
	
	/* An alias to make the class more "standards compliant" */
	function getUrl() {
	    return $this->tostring();
	}
	
	/* Returns url */
	function tostring() {
		return $this->data;
	}
	
	/* Formats a href */
	function tohref($name, $class = null, $id = null) {
	    $attribs = array();
	    
	    if ($class != null) {
	        $attribs[] = sprintf("class=\"%s\"", $class);
	    }
	    
	    if ($id != null) {
	        $attribs[] = sprintf("id=\"%s\"", $id);
	    }
	    
	    if ($this->rel != null) {
	        $attribs[] = sprintf("rel=\"%s\"", $this->rel);
	    }
	    
	    if ($this->lang != null) {
	        $attribs[] = sprintf("lang=\"%s\"", $this->lang);
	    }
	    
	    $href = sprintf("<a href=\"%s\" %s>%s</a>", $this->getUrl(), implode(" ", $attribs), $name);
	    
		return $href; //sprintf(getlangstring("FORMAT_HREF"), $href);
	}
	
	static function selfurl() {
		return htmlentities($_SERVER["REQUEST_URI"]);
	}
	
	static function homeurl() {
		$home = strrev($_SERVER['REQUEST_URI']);
		$home = strrev(substr($home, strpos($home, "/")));
		
		return "http://" . $_SERVER['HTTP_HOST'] . $home;
	}	
}
?>
