<?php
class XmlItem {
    function parseItem($xmldata) {
        // This will work but overloading this function is
        // strongly recommended. You won't have any use for
        // this anyway since your datastructure will have to
        // be defined for your application logic to work.
        die("Overload parseItem()");
        
        foreach ($xmldata as $key=>$value) {
            $member = strtolower($key);
            $this->$member = $value;
        }
    }

    /* Loads an XML file and parses it. See php.net documentation 
       http://php.net/xml_parser_create */
    static function getItemsFromXml($filename, $itemseparatortag) {
		$data    = file_get_contents($filename);
		$itemarr = null;
        $parser  = xml_parser_create();
        
        xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 1);
        xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
        xml_parse_into_struct($parser, $data, $values, $tags);
        xml_parser_free($parser);

        // loop through the structures
        foreach ($tags as $key=>$val)  {
            if ($key == strtoupper($itemseparatortag))  {
                $itemranges = $val;

                // each contiguous pair of array entries are the 
                // lower and upper range for each item definition
                for ($i = 0; $i < sizeof($itemranges); $i += 2) {
                    $offset = $itemranges[$i] + 1; // + 1 because we don't need to include the opening-tag
                    $len    = $itemranges[$i + 1] - $offset;

                    // iterate through the tags of each item and create
                    // structs into $itemarr which will be return by this function
                    foreach (array_slice($values, $offset, $len) as $tag) {
                        $itemarr[$i][strtolower($tag["tag"])] = $tag["value"];
                    }
                }
            }
        }
        return $itemarr;
    }
}
?>
