<?php 
function showform(&$configarr, $langkey) {
    global $config, $resp;
    
    $saveactionurl = new Url(Url::homeurl());
    $saveactionurl->addParam("act", "saveconfig");
    
	?>
	<h3><?php printlangstring($langkey); ?></h3>
	<form action="<?= $saveactionurl->getUrl() ?>" method="post">
	<table class="form">
	<tr>
		<th><?php printlangstring("PROMPT_NAME"); ?></th> 
		<th><?php printlangstring("PROMPT_VALUE"); ?></th> 
		<th><?php printlangstring("PROMPT_DEFAULTVALUE"); ?></th> 
		<th><?php printlangstring("PROMPT_HELP"); ?></th>
	</tr>
	<?php
	$count = 0;
	foreach ($configarr as $cfg) {
		if (! is_bool($cfg[1])) {
			printf(
				"<tr class=\"%s\"><td>%s</td><td><input type=\"text\" name=\"%s\" value=\"%s\" class=\"search\" size=\"35\" %s></td><td nowrap=\"nowrap\">%s</td><td>%s</td></tr>\n", 
				$resp->getAlternateStyle($count), $cfg[0], str_replace(".", "_", $cfg[0]), $config->get($cfg[0]), ($config->get("outputxhtml") ? "/":""), $cfg[1], getlangstring("CPANEL_HLP_" . strtoupper($cfg[0]))
			);
		} else {
			$trueopt  = sprintf("<label><input type=\"radio\" name=\"%s\" value=\"1\" class=\"search\" %s %s> Yes</label>", $cfg[0], ($config->get($cfg[0]) == true ? "checked" : ""), ($config->get("outputxhtml") ? "/":""));
			$falseopt = sprintf("<label><input type=\"radio\" name=\"%s\" value=\"0\" class=\"search\" %s %s> No</label>", $cfg[0], ($config->get($cfg[0]) == false ? "checked" : ""), ($config->get("outputxhtml") ? "/":""));
			
			printf(
				"<tr class=\"%s\"><td>%s</td><td>%s %s</td><td nowrap=\"nowrap\">%s</td><td>%s</td></tr>\n", 
				$resp->getAlternateStyle($count), $cfg[0], $trueopt, $falseopt, ($cfg[1] ? "Yes" : "No"), getlangstring("CPANEL_HLP_" . strtoupper($cfg[0]))
			);
		}
		
		$count++;
	}
	
	?>
	</table>
	<p class="clearfix"><input type="submit" value="<?php printlangstring("FUNC_SAVECONFIG"); ?>" class="button"></p>
	</form>
	<br>
	<?php
}

function showlangform() {
    global $config, $resp;
    
    $saveactionurl = new Url(Url::homeurl());
    $saveactionurl->addParam("act", "saveconfig");
    
    ?>
	<h3><a name="langcfg"></a><?php printlangstring("CPANEL_LANGCFG"); ?></h3>
	<form action="<?= $saveactionurl->getUrl() ?>" method="post">
    	<table class="form">
    	<tr>
    		<th class="formheading">Language name (internal name)</th> 
    		<th class="formheading" width="30%">Show in language-menu</th> 
    		<th class="formheading" width="30%">Default language</th> 
    	</tr>
    	
    	<?php
    	$count    = 0;
        $newlangs = array();
        $langs    = array();            
		foreach (glob($config->basedir() . $config->get('langdir') ."/*.txt") as $_lang) {
            preg_match("/(.*)_(.*){1}.txt/", $_lang, $regs);

            $cfg = $regs[2];

            printf("<tr class=\"%s\">", $resp->getAlternateStyle($count));
            if ($config->get("lang.$cfg") != '')  {                
                // installed languages
                $langs[] = $cfg;
                
                print("<td>". $config->get("lang.$cfg") ." (". $cfg .")</td>\n");
                
                $inmenu_trueopt  = sprintf("<label><input type=\"radio\" name=\"lang_%s_inmenu\" value=\"1\" class=\"search\" %s> Yes</label>", $cfg, ($config->get("lang.$cfg.inmenu") == true ? "checked" : ""));
                $inmenu_falseopt = sprintf("<label><input type=\"radio\" name=\"lang_%s_inmenu\" value=\"0\" class=\"search\" %s> No</label>", $cfg, ($config->get("lang.$cfg.inmenu") == false ? "checked" : ""));
                
                printf("<td>%s %s</td>\n", $inmenu_trueopt, $inmenu_falseopt);
                
                $deflang_opt = sprintf("<label><input type=\"radio\" name=\"defaultlang\" value=\"%s\" class=\"search\" %s> Yes</label>", $cfg, ($config->get("defaultlang") == $cfg ? "checked" : ""));
                
                printf("<td>%s</td>\n", $deflang_opt);
                
                printf("<input type=\"hidden\" name=\"lang_%s_name\" value=\"%s\">\n", 
                    $cfg, $config->get("lang.$cfg")
                );
            } else {
                // language not installed
                $newlangs[] = $cfg;
            }
            print("</tr>");
            
            $count++;
		}
        print("<input type=\"hidden\" name=\"languages\" value=\"". implode(",", $langs) ."\">\n");
	?>
	</table>
    
    <?php
        if (count($newlangs) > 0) {
            ?>
            <h3>Languages found on disk but not installed</h3>
            <table class="form">
            <tr>
                <th class="formheading">Identifier</th>
                <th class="formheading" width="30%">Install</th>
                <th class="formheading" width="30%">Name</th>
            </tr>
            <?php
            $count = 0;
            foreach ($newlangs as $cfg) {
                printf("<tr class=\"%s\">\n", $resp->getAlternateStyle($count));
                print("<td>$cfg</td>\n");
                print("<td>");
                    print("<label><input type=\"radio\" name=\"lang_{$cfg}_install\" value=\"1\"> Yes</label> ");
                    print("<label><input type=\"radio\" name=\"lang_{$cfg}_install\" value=\"0\" checked=\"checked\"> No</label> ");
                print("</td>\n");
                print("<td><input type=\"text\" class=\"search\" size=\"35\" name=\"lang_{$cfg}_name\" value=\"\"></td>\n");
                print("</tr>\n");
                
                $count++;
            }
            ?></table><?php
        }
        print("<input type=\"hidden\" name=\"newlangs\" value=\"". implode(",", $newlangs) ."\">\n");
    ?>
    
	<p class="clearfix"><input type="submit" value="<?php printlangstring("FUNC_SAVECONFIG"); ?>" class="button"></p>
	</form>
    <?php
} // showlangform

if ($_SESSION['admin']):
	$u_gen  = new Url(Url::homeurl()); $u_gen->addparam("act", "cpanel"); $u_gen->addparam("cat", "gen");
	$u_dir  = new Url(Url::homeurl()); $u_dir->addparam("act", "cpanel"); $u_dir->addparam("cat", "dir");
	$u_db   = new Url(Url::homeurl()); $u_db->addparam("act", "cpanel"); $u_db->addparam("cat", "db");
	$u_lang = new Url(Url::homeurl()); $u_lang->addparam("act", "cpanel"); $u_lang->addparam("cat", "lang");
	$u_theme = new Url(Url::homeurl()); $u_theme->addparam("act", "cpanel"); $u_theme->addparam("cat", "theme");
	
	$cpaneltools = array(
	        "gen"=>$u_gen,	        
    	    "theme"=>$u_theme,
    	    "lang"=>$u_lang,
    	    "db"=>$u_db,
    	    "dir"=>$u_dir,
	    );
    ?>
    
    <h2><?= getlangstring("ADMIN_CPANEL") ?></h2>
    <div id="cpanel">
    
        <div id="cpanelmenu">
        <ul class="navilist clearfix">
            <?php
                foreach ($cpaneltools as $label => $url) {
                    $langkey = "CPANEL_" . strtoupper($label) . "CFG";
                    $class   = isset($_GET['cat']) && $_GET['cat'] == $label ? "active" : "";
                    
                    printf("<li>%s</li>",
                        $url->tohref(getlangstring($langkey), $class)
                    );
                }    
            ?>
        </ul>	
        </div>
    	
    	<?php 
    	switch($_GET['cat']) {
    		case 'gen':
    			showform($config->configgen, "CPANEL_GENCFG");
    		break;
    		
    		case 'dir':
    			showform($config->configdir, "CPANEL_DIRCFG");
    		break;
    		
    		case 'db':
    			showform($config->configdb, "CPANEL_DBCFG");
    		break;
    		
    		case 'lang':
    		    showlangform();
    		break;
    		
    		case 'theme':
    		    print("<p>This is the theme admin. It is not yet done.</p>");
    		break;
    		
    		default:
    		    printf("<p>%s</p>", getlangstring("CPANEL_HLP_INTRODUCTION"));
    		break;
    	}
    	?>
	</div>	
    <?php 
else: 
	throw(new Exception("ERROR_NOTADMIN"));
endif;
?>