<?php
/********************/
/* Template helpers */
/********************/

    /* Are we starting a new thread or editing the first message */
    function isFirstInThread() {
        if (($_GET['act'] == 'post' && ! isset($_GET['tid'])) || ($_GET['act'] == 'edit' && ! isset($_GET['cid']))) {
            return true;
        }
        
        return false;
    }

    /* Are we viewing a single page (e.g. admin / posting form) */
    function isPage() {
        global $mode;
        
        return isset($mode); //isset($_GET['act']) || isset($_POST['act']);
    }
    
    /* Should we display just a single thread */
    function isSingleThread() {
        return isset($_GET['exp']);
    }

    /* Loads a single thread to be displayed */
    function getSingleThread() {
        global $coll, $thread, $theSinglethread, $config;
        
        // Reset variable so the previous cycle doesn't get propagated to following cycles
        $thread = null;
        
        // Fetch the requested thread
        $theSinglethread =& $coll->getThread($_GET['exp']);
        
        if ($theSinglethread !== false) {
            // Tools for admin
            if (isAdmin()) {
                $adm_pub   = new Url(Url::homeurl()); $adm_pub->addparam("act", "pub");     $adm_pub->addparam("tid", $theSinglethread->id);
    			$adm_stick = new Url(Url::homeurl()); $adm_stick->addparam("act", "stick"); $adm_stick->addparam("tid", $theSinglethread->id);
    			$adm_lock  = new Url(Url::homeurl()); $adm_lock->addparam("act", "lock");   $adm_lock->addparam("tid", $theSinglethread->id);
    			$adm_edit  = new Url(Url::homeurl()); $adm_edit->addparam("act", "edit");   $adm_edit->addparam("tid", $theSinglethread->id);
    			$adm_dele  = new Url("javascript:confirmDelete(" . $theSinglethread->id . ",-1)");
    
    			$admtools   = array();
    			$admtools[] = $adm_pub->tohref((! $theSinglethread->isPublic() ? getlangstring("ADMIN_PUBLISH") : getlangstring("ADMIN_HIDE")), "admin publish");
    			$admtools[] = $adm_stick->tohref((! $theSinglethread->isSticky() ? getlangstring("ADMIN_STICK") : getlangstring("ADMIN_UNSTICK")), "admin stick");
    			$admtools[] = $adm_lock->tohref((! $theSinglethread->isLocked() ? getlangstring("ADMIN_LOCK") : getlangstring("ADMIN_UNLOCK")), "admin lock");
    			$admtools[] = $adm_edit->tohref(getlangstring("ADMIN_MODIFY"), "admin edit");
    			$admtools[] = $adm_dele->tohref(getlangstring("ADMIN_DELETE"), "admin delete");
    			
    			$thread->admin = implode(" ", $admtools);
            } else {
                $thread->admin = "";
            }
            
            // Tools for user
            $utools   = array();
            $u_quo    = new Url(Url::selfurl()); $u_quo->addparam("act", "post"); $u_quo->addparam("tid", $theSinglethread->id); $u_quo->addparam("quote", 0);
			$u_post   = new Url(Url::selfurl()); $u_post->addparam("act", "post"); $u_post->addparam("tid", $theSinglethread->id); 
			$utools[] = $u_quo->tohref(getlangstring("FUNC_QUOTE"), "tools quotereply");
			$utools[] = $u_post->tohref(getlangstring("FUNC_POSTREPLY"), "tools reply");
            
            $thread->tools        = implode(" ", $utools);
            
            // Collect attributes
    		$attribs = array();
    		if ($theSinglethread->isLocked()) {
    		    $attribs[] = sprintf("<span class=\"attribute %s\">%s</span>", 'locked', getlangstring("PROMPT_LOCKED"));
    		}
    		
    		if ($theSinglethread->isSticky()) {
    		    $attribs[] = sprintf("<span class=\"attribute %s\">%s</span>", 'sticky', getlangstring("PROMPT_STICKY"));
    		}
    		
    		if (! $theSinglethread->isPublic()) {
    		    $attribs[] = sprintf("<span class=\"attribute %s\">%s</span>", 'review', getlangstring("PROMPT_REVIEW"));
    		}
    		
    		// Set attributes collectively and separately
    		$thread->attribs      = implode(" ", $attribs);
            $thread->sticky       = $theSinglethread->isSticky() ? "sticky" : "";
            $thread->locked       = $theSinglethread->isLocked() ? "locked" : "";
            $thread->public       = $theSinglethread->isPublic() ? "" : "review";
            
            // Other variables
            $thread->fromip       = isAdmin() ? $tmpThread->ipaddr : "";
            $thread->anchor       = $theSinglethread->getAnchor();
            $thread->posted       = date($config->get('dateformat'), strtotime($theSinglethread->posted));            
            $thread->replycnt     = isAdmin()  ? $theSinglethread->getCommentCnt() : $theSinglethread->getPublicCommentCnt();
            $thread->postedby     = $theSinglethread->creator;
            $thread->lastpostwhen = dateformat($theSinglethread->modified);
            $thread->lastpostby   = $theSinglethread->getLastCommenter();
            $thread->title        = wwwsafe(&$theSinglethread->topic, false);
            $thread->numcomments  = $theSinglethread->getCommentCnt();
            
            $thread->body         = parsequotes(wwwsafe($theSinglethread->bread));
            
            // don't know why, but this is needed.
            reset($theSinglethread->comments);
            
            return true;
        }
        
        return false;
    }
    
    // Helper function to wrap links
    function wrapify($linkarray) {
        global $resp;
        
        foreach ($linkarray as $ind => $val) {
		    $linkarray[$ind] = $resp->wrapLink($val);
		}
    }

    /* Get next comment from the current thread being displayed */
    function getNextComment() {
        global $thread, $theSinglethread, $config;
        
        // reset variable so the previous cycle doesn't get propagated to following cycles
        $thread = null;
        
        if ($theSinglethread === false) {
            return;
        }
        
        // load the next comment
        $theItem =& $theSinglethread->getNextComment();
        
        if ($theItem !== false) {
            $tmpItem = $theItem;
            
            // Tools for admins
			if (isAdmin()) {
			    $adm_pub  = new Url(Url::homeurl()); $adm_pub->addparam("act", "pub");   $adm_pub->addparam("tid", $theSinglethread->id);  $adm_pub->addparam("cid", $tmpItem->id);
    			$adm_edit = new Url(Url::homeurl()); $adm_edit->addparam("act", "edit"); $adm_edit->addparam("tid", $theSinglethread->id); $adm_edit->addparam("cid", $tmpItem->id);
    			$adm_dele = new Url("javascript:confirmDelete(" . $theSinglethread->id . "," . $tmpItem->id . ")");
    			
    			$admtools   = array();
				$admtools[] = $adm_pub->tohref((! $tmpItem->isPublic() ? getlangstring("ADMIN_PUBLISH") : getlangstring("ADMIN_HIDE")), "admin");
				$admtools[] = $adm_edit->tohref(getlangstring("ADMIN_MODIFY"), "admin edit");
				$admtools[] = $adm_dele->tohref(getlangstring("ADMIN_DELETE"), "admin delete");
    			
				// Wrap tool-links as defined in the theme
				wrapify(&$admtools);
				
    			$thread->admin = implode(" ", $admtools);
			} else {
			    $thread->admin = "";
			}
			
			// Tools for users			
			$u_top = new Url("#top");
			$u_quo = new Url(Url::selfurl()); $u_quo->addparam("act", "post"); $u_quo->addparam("tid", $theSinglethread->id); $u_quo->addparam("quote", $tmpItem->id);
    		$u_rep = new Url(Url::selfurl()); $u_rep->addparam("act", "post"); $u_rep->addparam("tid", $theSinglethread->id);
    		
    		$utools = array();
			if (! $theSinglethread->isLocked()) {
    			$utools[] = $u_quo->tohref(getlangstring("FUNC_QUOTE"), "tools quotereply");
				$utools[] = $u_rep->tohref(getlangstring("FUNC_POSTREPLY"), "tools reply"); 
			}
			$utools[] = $u_top->tohref(getlangstring("FUNC_TOTOP"), "tools topreturn");
			
			// Wrap tool-links as defined in the theme
			wrapify($utools);
			
			$thread->tools = implode(" ", $utools);
			
			// Other variables
            $thread->anchor   = $tmpItem->getAnchor();
            $thread->attribs  = ($tmpItem->public ? "" : getlangstring("PROMPT_REVIEW") . " ");
            $thread->fromip   = isAdmin() ? $tmpItem->ipaddr : "";
            $thread->posted   = date($config->get('dateformat'), strtotime($tmpItem->posted));
            $thread->postedby = $tmpItem->creator;
            $thread->body     = parsequotes(wwwsafe($tmpItem->bread));
            
            return true;
        }
        
        return false;
    }

    /* Updates variables or return false on all threads displayed */
    function getNextThread() {
        global $coll, $thread, $threadsdisplayed, $config, $resp;

        if (isset($resp->searchResults)) {
            $tmpThread = current($resp->searchResults);
            next($resp->searchResults);
        } else {
            if (isAdmin()) {
                $tmpThread = $coll->getNext();
            } else {
                $tmpThread = $coll->getNextPublic();
            }
        }
            
        if ($tmpThread !== false) {
            $lnkfrst = new Url(Url::homeurl());
    		$lnkfrst->addparam("exp", $tmpThread->id);
    		//$lnkfrst->addparam("pg", 0);
            
    		// Collect attributes
    		$attribs = array();
    		if ($tmpThread->isLocked()) {
    		    $attribs[] = sprintf("<span class=\"attribute %s\">%s</span>", 'locked', getlangstring("PROMPT_LOCKED"));
    		}
    		
    		if ($tmpThread->isSticky()) {
    		    $attribs[] = sprintf("<span class=\"attribute %s\">%s</span>", 'sticky', getlangstring("PROMPT_STICKY"));
    		}
    		
    		if (! $tmpThread->isPublic()) {
    		    $attribs[] = sprintf("<span class=\"attribute %s\">%s</span>", 'review', getlangstring("PROMPT_REVIEW"));
    		}
    		
    		// Set attributes collectively and separately
    		$thread->attribs      = implode(" ", $attribs);
            $thread->sticky       = $tmpThread->isSticky() ? "sticky" : "";
            $thread->locked       = $tmpThread->isLocked() ? "locked" : "";
            $thread->public       = $tmpThread->isPublic() ? "" : "review";
            
    		// Assign variables
    		$thread->anchor       = $tmpThread->getAnchor();
            $thread->posted       = date($config->get('dateformat'), strtotime($tmpThread->posted));
            $thread->replycnt     = isAdmin()  ? $tmpThread->getCommentCnt() : $tmpThread->getPublicCommentCnt();
            $thread->postedby     = $tmpThread->creator;
            $thread->lastpostwhen = dateformat($tmpThread->modified);
            $thread->lastpostby   = $tmpThread->getLastCommenter();
            $thread->lastpostlink = $tmpThread->getLastCommentLink();
            $thread->title        = sprintf("<a href=\"%s\">%s</a> &raquo;", $lnkfrst->tostring(), wwwsafe(&$tmpThread->topic, false));
            
            // Count displayed threads
            $threadsdisplayed++;
            
            return true;
        }
        
        return false;
    }

    /* Is the current user logged in as an admin */
    function isAdmin() {
        return $_SESSION['admin'];
    }
    
/**************************/
/* User related functions */
/**************************/

    /* Stores the name given when posting in a cookie */
    function storePosterName($name) {
        global $config;
        
        $cookielife  = $config->get('cookielifetime');
        $ccookietod = time() + (60*60*24*30*$cookielife);
        
        setcookie("elfbb_pname", $name, $ccookietod);
    }
    
    /* Retrieves the name from the cookie */
    function getPosterName() {
        if (! empty($_COOKIE['elfbb_pname'])) {
            return $_COOKIE['elfbb_pname'];
        }
        
        return '';
    }

/*****************************/
/* Text formatting functions */
/*****************************/

    /* Wrap long words in order to keep them from breaking the layout */
	function smartwrap(&$str) {
	    global $config;
	    
	    /* 
    		This function now only looks for very long words. It's up to the browser to not break the layout. 
    		It shouldn't break href:s, if it does it's a bug.
    	*/
		if ($config->get('maxwordlen') == 0) {
			return $str;
		}
	
		$linebreak    = "\n<br><!-- ww -->"; // replace this with your favourite linebreak
		$splitmessage = preg_split("/[\s]+/", $str); // split message into string tokens (words)

		foreach ($splitmessage as $word) {
			if (strstr($word, "href=") === false) {
			    // If no url was found it's safe to wrap the word
				$strtmp .= wordwrap($word, $config->get('maxwordlen'), $linebreak, true) . " ";
			} else {
				/* Let's try to be nice to long urls. (Means we don't split the tag but the content) 
				 * Quite hackish code but it should serve it's purpose... */
				$spos = strpos($word, ">", 0);
				
				if ($spos === false) {
					$strtmp .= $word;
				} else {
					$strtmp .= substr($word, 0, $spos + 1);
					$epos    = strpos($word, "<", $spos + 1);
					
					if ($epos === false) {
						$strtmp .= substr($word, $spos + 1);
					} else {
						$strtmp .= wordwrap(substr($word, $spos + 1, $epos - $spos - 1), $config->get('maxwordlen'), $linebreak, true);
						$strtmp .= substr($word, $epos) . " ";
					}
				}
			}
		}
				
		return $strtmp;
	}
	
	/* Formats a date as per to the configuration */
	function dateformat(&$date) {
	    global $config;
	    
		return date($config->get('dateformat'), strtotime($date));
	}

    /* Parses quote boxes */
    /*
        This is something that is going to be optimized some time in the future.
        As for know, I just needed something that works to avoid getting stuck.
    */
    function parsequotes($str) {
        $spos = strpos($str, "[quote");        
        if ($spos === false) {
            return $str;
        }
        
        $epos = strpos($str, "]", $spos);
        if ($epos === false) {
            return $str;
        }
        
        $qepos = strpos($str, "[/quote]", $epos);
        if ($qepos === false) {
            return $str;
        }
        
        // using substr because I haven't yet managed to compile a decent regexp to get me out of trouble
        $quotestr = substr($str, $spos, ($epos - $spos) + 1); // extract the [quote]
        $quotetxt = substr($str, $epos + 1, $qepos - $epos - 1); // extract the quote body
        
        // split the quotestring with a regexp
        preg_match('/\[quote author=(.*) date=(.*) src=(.*)\]/', $quotestr, $matches);
        
        $quoteAuthor = trim($matches[1]) == "" ? "Anonymous" : trim($matches[1]);
        $quoteDate   = trim($matches[2]) == "" ? "" : dateformat(trim($matches[2]));
        $quoteAnchor = sprintf("#%s", trim($matches[3]));
        
        if (count($matches) == 4) {
            $quotehead = getlangstring("FORMAT_QUOTE_FULL");
            
            $quotehead = str_replace("%url", $quoteAnchor, $quotehead);
            $quotehead = str_replace("%who", $quoteAuthor, $quotehead);
            $quotehead = str_replace("%when", dateformat($quoteDate), $quotehead);
        } else {
            $quotehead = getlangstring("FORMAT_QUOTE_SIMPLE");
        }
        
        $thequote = sprintf("<div class=\"quotebox\">%s<div class=\"quote\">%s</div></div>", 
            $quotehead, $quotetxt
        );
        
        $head = substr($str, 0, $spos);
        $tail = substr($str, $qepos + 8);
        $str  = parsequotes($head . $thequote . $tail);
        
		return $str;
	}
	
	/* Format text into a web format a.k.a. strip all html and translate bbcode and urls */
	function wwwsafe($str, $wrap = true) {		
		// Fix linebreaks, illegal chars, and slashed chars
		$str = str_replace("[br]", "<br/>\n", htmlspecialchars(stripslashes($str)));
		
		//  Fix allowed bb-tags
		$str = preg_replace("/(\[)([bBiIuU]{1})(\])/", "<\$2>", $str);
		$str = preg_replace("/(\[)\/([bBiIuU]{1})(\])/", "</\$2>", $str);
		
		// Make urls into hrefs. 
        $hrefstr = sprintf("<a class=\"linkinpost\" title=\"%s: $1://$2$5\" href=\"$1://$2$5\">$2$5</a> ", getlangstring("FUNC_GOTO"));
        $str     = preg_replace(
                        "/(http[s]{0,1}):\/\/(([a-z]{1}[a-z0-9-]{1,}\.){1,}([a-z]{2,7}))(\/([^\s\"<>\[]{0,})){0,}/",                     
                        $hrefstr, 
                        $str                
                    );
        
		return ($wrap ? smartwrap($str) : $str);
	}

/**********************************************************/
/* Inner workings a.k.a. old stuff that should be checked */
/**********************************************************/

    /* Get the clients' IP-address so it can be logged */
	function getclientaddress() {
		if ($_SERVER["HTTP_X_FORWARDED_FOR"])  {
			$rip = $_SERVER["HTTP_X_FORWARDED_FOR"];
		} elseif ($_SERVER["HTTP_CLIENT_IP"])  {
			$rip = $_SERVER["HTTP_CLIENT_IP"];
		} else  {
			$rip = $_SERVER["REMOTE_ADDR"];
		} 

		return $rip; 
	}

    /* Displaying debug messages */
	function debugmessage($str) {
	    global $config;
	    
	    // Only if debug messages are set to true */
		if ($config->get('showdebugmessages')) {
			printf("<p class=\"debugmessage\">%s</p>", $str);
		}
	}
	
	/* Dipslay error messages */
	function errormsg($str) {
		$err = getlangstring("FORMAT_ERRORMSG");
		return sprintf($err, $str);
	}
	
	/* Send e-mails about new threads to all users listed to receive them */
	function sendnotifymails($who, $what) {
	    global $config;
	    
        $subject       = $config->get("notifymail.topic");
        $sender        = $config->get('notifymail.sender.name') . "<" . $config->get('notifymail.sender.email') . ">";
		$recipientlist = explode(",", $config->get('notifymail.recipients'));
		
		if (! is_array($recipientlist)) {
		    // Do nothing if no recipients are configured
			return;
		}
	
		$loginurl = new Url(Url::homeurl());
		$loginurl->addparam("act", "login");

		foreach ($recipientlist as $recipient) {
			$emailbody = sprintf("%s %s %s\r\n\r\n%s", 
    			    $who, 
    			    stripslashes(getlangstring("NOTIFYMAIL_MESSAGE")), 
    			    $what, 
    			    $loginurl->tostring()
			    );
			
			mail($recipient, $subject, $emailbody, ("From: " . $sender));
		}
	}
	
/****************************/
/* General helper functions */
/****************************/
	
	function endsWith($str, $test) {
		$thestr = strrev($str);
		
		if (strcmp($test, substr($thestr, 0, strlen($test))) == 0) {
			return true;
		}
		
		return false;
	}

    /* 
        This check is probably unnecessary by now, but originally this was
        a function that you couldn't count on being present
    */
	if (! function_exists('stripos')) {
		function stripos($haystack, $needle) {
			return strpos(strtolower($haystack), strtolower($needle));
		}
	}
	
	/* 
        This check is probably unnecessary by now, but originally this was
        a function that you couldn't count on being present
    */
	if (! function_exists('file_get_contents')) {
		function file_get_contents($filename, $use_include_path = 0) {
			if (file_exists($filename)) {
				return implode("", file($filename));
			}
			
			throw(new Exception("FILE_NOT_FOUND"));
		}
	} 

/***************/
/* END OF FILE */
/***************/
	
 /*
    Saving this old code here, so I can make a migration tool for upgrades. Some day. Maybe. Probably not.
	function parsequotes($str, $thread) {
		$pos = 0;

		while (strpos($str, "[quote ", $pos) !== false) {
			$spos = strpos($str, "[quote ", $pos);
			if ($spos === false) {
				break;
			}
			
			$epos = strpos($str, "]", $spos);
			if ($epos === false) {
				break;
			}
			
			$idn       = trim(substr($str, $spos + 7, $epos - $spos - 7));
			$quotehead = errormsg(getlangstring("ERROR_SOURCENOTFOUND"));

			if ($idn == 0) {
				$quotehead = sprintf("<div class=\"quote\">" . getlangstring("FORMAT_QUOTE"), dateformat($thread->posted), $thread->creator);
			} else {
				foreach ($thread->comments as $comment) {
					if ($comment->id == $idn) {
						$quotehead = sprintf("<div class=\"quote\">" . getlangstring("FORMAT_QUOTE"), dateformat($comment->posted), $comment->creator);
						break;
					}
				}
			}
			
			$head = substr($str, 0, $spos);
			$tail = substr($str, $spos);
			$str  = $head . $quotehead . $tail;
			$pos  = $epos + strlen($quotehead) + 1;
		}
		
		$str = preg_replace("/\[quote [0-9]+\]/", "<div class=\"quotebox\">", $str);
		$str = str_replace("[/quote]", "</div></div>", $str);
		
		return $str;
	}
*/	
?>
