<?php
    // Form action
    $formAction = new Url(Url::homeUrl());
    $formAction->addParam("act", "save");    
    $resp->formAction   = $formAction->tostring();
    
    // Poster name
    $resp->valueName = getPosterName();
    
    // Form captions
    $resp->captionTopic   = getlangstring("PROMPT_TOPIC");
    $resp->captionMessage = getlangstring("PROMPT_MESSAGE");
    $resp->captionName    = getlangstring("PROMPT_YOURNAME");
    
    // Button captions
    $resp->buttonSend     = getlangstring("FUNC_SENDFORM");
    $resp->buttonReset    = getlangstring("FUNC_RESETFORM");

    // Form field size
    $resp->formFieldsize  = $config->get('composefieldsize');

    // Reset the rest of the form-related vars to reduce redundancy
    $resp->valueTopic     = "";
    $resp->valueMessage   = "";

    // Init array for meta fields
    $hidden               = array();
    
    /*********************************************************/

	if ($mode == "edit" && isset($_GET['cid'])) {    
        // Editing a comment in a thread
        $theThread  = $coll->getThread($_GET['tid']);
        $theComment = $theThread->getComment($_GET['cid']);    
    
		$hidden[] = sprintf("<input type=\"hidden\" name=\"tid\" value=\"%s\">", $theThread->getId());
		$hidden[] = sprintf("<input type=\"hidden\" name=\"cid\" value=\"%s\">", $theComment->getId());
		
		$resp->formHeading  = getlangstring("PROMPT_EDITREPLY");
        $resp->valueTopic   = htmlspecialchars(stripslashes($theThread->topic));
        $resp->valueMessage = htmlspecialchars(stripslashes(str_replace("[br]", chr(13), $theComment->bread)));
        
        // Override the stored alias of the writer
        // since it is possibly not the same person
        $resp->valueName = $theComment->creator;
        
	} elseif ($mode == "edit" && isset($_GET['tid'])) {
        // Editing the first message in a thread
        $theThread = $coll->getThread($_GET['tid']);
        
        $hidden[] = sprintf("<input type=\"hidden\" name=\"tid\" value=\"%s\">", $theThread->getId());
    
		$resp->formHeading  = getlangstring("PROMPT_EDITPOST");
        $resp->valueTopic   = htmlspecialchars(stripslashes($theThread->topic));
        $resp->valueMessage = htmlspecialchars(stripslashes(str_replace("[br]", chr(13), $theThread->bread)));
        
        // Override the stored alias of the writer
        // since it is possibly not the same person
        $resp->valueName    = $theThread->creator;
        
	} elseif (isset($_GET['tid'])) {
        // Posting a new comment in an existing thread
        $theThread = $coll->getThread($_GET['tid']);
        
		$hidden[] = sprintf("<input type=\"hidden\" name=\"itemid\" value=\"%s\">", $theThread->getId());
        
        $resp->formHeading = getlangstring("PROMPT_POSTREPLY");
        $resp->valueTopic  = htmlspecialchars(stripslashes($theThread->topic));
        
        // Retrieve quoted message
        if (isset($_GET['quote'])) {
        	if ($_GET['quote'] == 0) {
        		$quoteSource =& $theThread;
        	} else {
        		$quoteSource =& $theThread->getComment($_GET['quote']);
        	}
        	
        	$quoteStr = sprintf("[quote author=%s date=%s src=%s]%s[/quote]",
					$quoteSource->creator,
					$quoteSource->posted,
					$quoteSource->getAnchor(),
					str_replace("[br]", chr(13), trim($quoteSource->bread))
	        	);
	        	
	        $resp->valueMessage = $quoteStr;
    	}
	} else {
		$resp->formHeading = getlangstring("PROMPT_POSTNEW");
	}
    
    // Combine meta fields into one
    $resp->formMeta    = implode("\n", $hidden);
	
	require_once($themedir . "/form.tmpl.php");
?>