<?php
$performSave = true;

if ($mode == "save") {
	if (isset($_POST['cid'])) {
		// Editing a comment
		
		if (! isAdmin()) {
			throw(new Exception("ERROR_NOTADMIN"));
		}
		
		$expid = $_POST['tid'] . "#cm" . $_POST['cid'];

		if (! $config->get('usedb')) {
			// Load the thread and the comment
			$theThread  =& $coll->getThread($_POST['tid']);
			$theComment =& $theThread->getComment($_POST['cid']);
			
			// Update the comment
			$theComment->bread   = stripslashes(str_replace(chr(13), "[br]", $_POST['mbody']));
			$theComment->creator = $_POST['malias'];
			
			// Update the timestamps
			$theComment->touch();
			$theThread->touch();
			
			print("<p>" . getlangstring("PROMPT_SAVEOK") . "</p>");
		} else {
			$dbc = new dbconn();
            
            // update comment
			$sql = sprintf("UPDATE bbreply SET bread = '%s', creator = '%s' WHERE id = %d AND itemid = %d",
				$dbc->escape(stripslashes(str_replace(chr(13), "[br]", $_POST['mbody']))), $dbc->escape($_POST['malias']), $_POST['cid'], $_POST['tid']
			);
			$dbc->query($sql);
            
            // update thread timestamp
            $sql = sprintf("UPDATE bbthread SET modified = NOW() WHERE id = %d",
				$_POST['tid']
			);
            $dbc->query($sql);
		}
	} elseif (isset($_POST['tid'])) {
		// Editing the first message in a thread
		
		if (! isAdmin()) {
			throw(new Exception("ERROR_NOTADMIN"));
		}
		
		$expid = $_POST['tid'];
		
		if (! $config->get('usedb')) {
			// Load the thread
			$theThread =& $coll->getThread($_POST['tid']);
			
			// Update the message
			$theThread->topic   = $_POST['mtopic'];
			$theThread->creator = $_POST['malias'];
			$theThread->bread   = stripslashes(str_replace(chr(13), "[br]", $_POST['mbody']));
			
			// Update the timestamp
			$theThread->touch();			
        } else {
			$dbc = new dbconn();
			$sql = sprintf("UPDATE bbthread SET modified = NOW(), topic = '%s', bread = '%s', creator = '%s' WHERE id = %d",
				$dbc->escape($_POST['mtopic']), $dbc->escape(stripslashes(str_replace(chr(13), "[br]", $_POST['mbody']))), $dbc->escape($_POST['malias']), $_POST['tid']
			);
			$dbc->query($sql);
		}
		
        print("<p>" . getlangstring("PROMPT_SAVEOK") . "</p>");		
	} elseif (! isset($_POST['itemid'])) {
		// Starting a new thread
		
        if (empty($_POST['mtopic']) || empty($_POST['malias']) || empty($_POST['mbody'])) {
        	// Required fields left empty
        	
            print(errormsg(getlangstring("ERROR_REQUIREDFIELDSLEFTEMPTY")));
            $performSave = false;
        } else {
        	// Create a new thread
        	
            $new = new BBItem();
            $new->public   = $config->get('hidenewposts') ? 0 : 1;
            $new->sticky   = 0;
            $new->locked   = 0;
            $new->creator  = $_POST['malias'];
            $new->ipaddr   = getclientaddress();
            $new->topic    = $_POST['mtopic'];
            $new->bread    = stripslashes(str_replace(chr(13), "[br]", $_POST['mbody']));
            
            // Add it to the collection
            $newid = $coll->addItem($new);
            
            // Send notification e-mails about the new thread
            sendnotifymails($new->creator, $new->topic);
            
            if (! $config->get('hidenewposts')) {
                $expid = $new->getId();
            }
            
            print("<p>" . getlangstring("PROMPT_SAVEOK") . "</p>");
        }
        
        // Store poster name only on new posts
        storePostername($_POST['malias']);
	} else {
		// Posting a comment in an existing thread
		
        if (empty($_POST['malias']) || empty($_POST['mbody'])) {
        	// Required fields left empty
            throw(new Exception("ERROR_REQUIREDFIELDSLEFTEMPTY"));
            $performSave = false;
        } else {
        	// Load the thread
        	$theThread =& $coll->getThread($_POST['itemid']);
        	
        	// This shouldn't happen, but it's not that hard to achieve
        	if ($theThread->isLocked()) {
        		throw(new Exception("ERROR_LOCKEDTHREAD"));
        	}
        	
        	// Create a new comment
            $new = new Comment();
            $new->public   = $config->get('hidenewposts') ? 0 : 1;
            $new->itemid   = $_POST['itemid'];
            $new->creator  = $_POST['malias'];
            $new->ipaddr   = getclientaddress();
            $new->bread    = stripslashes(str_replace(chr(13), "[br]", $_POST['mbody']));
            
            // Add comment to the collection
            $newcid = $coll->addItemComment($new);
            $expid  = $theThread->getId() . "#cm" . $newcid;
	
            // Update the threads' timestamp
            // Note! This is a bit problematic, since it can cause apparent incosistency
            // on moderated boards when the timestamp is updated but the messages are kept
            // invisible
			$theThread->touch();
            
            printf("<p>%s</p>", getlangstring("PROMPT_SAVEOK"));
        }
        
        // Store poster name only on new posts
        storePostername($_POST['malias']);
	}
} elseif ($mode == "dele") {
	if (isAdmin()) {
		// Saving is handled within the removal code
		// so no need to repeat it here
		$performSave = false; 
		$saveok      = true; // We're also assuming (for now) that the save goes through ok
		
		if (isset($_GET['cid'])) {
			$expid = $_GET['tid'];
			
			$thread  = $coll->getThread($_GET['tid']);
			$comment = $thread->getComment($_GET['cid']);
			
			if ($coll->removeItemComment($thread, $comment)) {			
				print("<p>" . getlangstring("PROMPT_MESGDELETEOK") . "</p>");
			}			
		} elseif (isset($_GET['tid'])) {
			$thread = $coll->getThread($_GET['tid']);
			
			if ($coll->removeItem($thread)) {			
				print("<p>" . getlangstring("PROMPT_THRDDELETEOK") . "</p>");
			}
		}
	} else {
		throw(new Exception("ERROR_NOTADMIN"));
	}
}

if ($performSave) {
    $saveok = $coll->saveThreads();
}
?>

<?php if ($saveok): ?>
    <script type="text/javascript">
    	<?php if (isset($expid)): ?>
    		function go() {
				clearInterval(dlay);
    			tid = '<?php print($expid) ?>';
    			document.location = './?pg=last&exp=' + tid;
    		}
    	<?php else: ?>
    		function go() {
				clearInterval(dlay);
    			document.location = './'
    		}
    	<?php endif; ?>
    	
    	dlay = setInterval('go()', <?php print($config->get('redirectdelay'));?>);
    </script>
    
    <?php if ($config->get('hidenewposts') && ! $_SESSION['admin']): ?>
    <p><?php printlangstring("PROMPT_MODERATEDPOST"); ?>.</p>
    <?php endif; ?>

    <p><?php printlangstring("PROMPT_REDIRECTED"); ?>.</p>
    <p><a href="./<?php print((isset($expid) ? ("?pg=last&amp;exp=" . $expid) : "")); ?>"><?php printlangstring("PROMPT_CONTINUE"); ?> &raquo;</a></p>
<?php else: ?>
    <?php if ($performSave): ?>
    <p>
        <?php printf(errormsg(getlangstring("ERROR_SAVEFAIL")),
                "<a href=\"javascript:location.reload(true)\">" .
                getlangstring("FUNC_REFRESH") . "</a>"
        ); ?>
    </p>
    <?php else: ?>
    <p>
        <?php printf(errormsg(getlangstring("ERROR_NOSAVERETURN")),
                "<a href=\"javascript:history.back()\">" .
                getlangstring("FUNC_RETURN") . "</a>"
        ); ?>
    </p>
    <?php endif; ?>
<?php endif; ?>
