<?php 
    $reqstart = microtime(true);
	session_start(); 

    /* Include and instantiate Configuration */
	require_once("../Configuration.php");
	$config = Configuration::getInstance();
	$config->loadConfig($config->basedir() . "/config.php");

	/* Include the class-files */
    require_once($config->basedir() . $config->get('classdir') . "/Response.php");
	require_once($config->basedir() . $config->get('classdir') . "/Language.php");
	require_once($config->basedir() . $config->get('classdir') . "/Url.php");
	require_once($config->basedir() . $config->get('classdir') . "/XmlItem.php");
	require_once($config->basedir() . $config->get('classdir') . "/BBItem.php");
	require_once($config->basedir() . $config->get('classdir') . "/Comment.php");
	require_once($config->basedir() . $config->get('classdir') . "/BBCollection.php");
	
	/* Include MySQL-class if db is used for storage */
	if ($config->get('usedb')) {
		require_once($config->basedir() . $config->get('classdir') . "/db_mysql.php");
	}

	/* Include helper files */	
	require_once($config->basedir() . $config->get('includedir') . "/functions.php");
    require_once($config->basedir() . $config->get('includedir') . "/auth.php");
	require_once($config->basedir() . $config->get('includedir') . "/lang.php");

    /* Instantiate the BBCollection and Response */
	$coll = BBCollection::getInstance();
	$resp = Response::getInstance();
    
	// Load the messages
	if ($config->get('usedb')) {
		$coll->loadDataMysql();
	} else {
		$coll->loadData();
	}
	
	// sort the threads
	$coll->sortItems("desc");
	
	// Initialize
    $thread           = null;
    $threadsdisplayed = 0;

    // Current theme
    $currenttheme = "default";
	$themedir     = "themes/" . $currenttheme;

    // Include theme definitions
    require_once($themedir . "/theme-defs.php");

	ob_start();
	
	// If an action is desired...
	if (isset($_GET['act']) || isset($_POST['act'])) {
		$mode = (isset($_GET['act']) ? $_GET['act'] : $_POST['act']);
        
		// ...the required controller is included here
		
		try {
			switch ($mode) {		    
			    // Post a new or edit a message
				case 'edit':
				case 'post':
					require_once($config->basedir() . $config->get('includedir') . "/post.php");
				break;
				
				// Delete or save a thread
				case 'dele':
				case 'save':
					require_once($config->basedir() . $config->get('includedir') . "/save.php");
				break;
				
				// Show the login form
				case 'login':
					require_once($config->basedir() . $config->get('includedir') . "/login.php");
				break;
				
				// Publish or hide a thread or message
				case 'pub':
					require_once($config->basedir() . $config->get('includedir') . "/publish.php");
				break;
				
				// Stick a thread
				case 'stick':
					require_once($config->basedir() . $config->get('includedir') . "/stick.php");
				break;
				
				// Lock a thread
				case 'lock':
					require_once($config->basedir() . $config->get('includedir') . "/lock.php");
				break;
				
				// Perform search
				case 'search':
					require_once($config->basedir() . $config->get('includedir') . "/search.php");
					unset($mode); // unsetting mode in order to display search results
				break;
				
				// Save configuration and redisplay the cpanel
				case 'saveconfig':			    
					require_once($config->basedir() . $config->get('includedir') . "/saveconfig.php");
				
				// Control panel
				case 'cpanel':
					require_once($config->basedir() . $config->get('includedir') . "/cpanel.php");
				break;
				
				// No match
				default:
				    throw(new Exception("ERROR_NOTFOUND"));
				break;
			}
		} catch (Exception $e) {
			print(errormsg(getlangstring($e->getMessage())));
		}
	}
	
	$resp->setBody(ob_get_contents());
	ob_end_clean();
	
	if (isset($authfailure)) {
		//$body = errormsg(getlangstring("ERROR_AUTHFAIL"));
		$resp->setBody(errormsg(getlangstring("ERROR_AUTHFAIL")));
	}
	
    include($themedir . "/index.tmpl.php");
?>
